/*
 * Project name:
     GSM2.vtft
 * Generated by:
     Visual TFT
 * Date of creation
     6/15/2013
 * Time of creation
     9:41:07 AM
 * Test configuration:
     MCU:             STM32F407ZG
     Dev.Board:       Mikromedia_Plus_for_STM32_ARM
                      http://www.mikroe.com/mikromedia/plus/stm32-m4/
     Oscillator:      150000000 Hz
     SW:              mikroC PRO for ARM
                      http://www.mikroe.com/mikroc/arm/
 */


// Include Files
#include "GSM2_objects.h"
#include "UART2.h"
#include "UART6.h"
#include "App.h"
#include "Timers.h"

// Variables



void main() {

     Start_TP();                   // Initialize touch panel
     UART2_Initialize();           // Initialize serial interface for click modules
     UART6_Initialize();           // Initialize serial interface for diagnostic messages
     UART6_PutQueue("Started\r\n");
     GSM2_Initialize();            // Initialize GSM2 click board
     TimerInit();                  // Initialize timer

     EnableInterrupts();           // Enable interrupts

     while (1) {
         Check_TP();
         UART2_Rx();
         UART2_CheckQueue();
         UART6_Rx();
         UART6_CheckQueue();
         GSM2_TaskMgr();
         TimerCheck();
     }
}