#line 1 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/GSM2_main.c"
#line 1 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/gsm2_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct {
 unsigned int X_Min;
 unsigned int X_Max;
 unsigned int Y_Min;
 unsigned int Y_Max;
 char Rotate;
} TTPConstants;

typedef struct Button {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int ButtonsCount;
 TButton * const code *Buttons;
};

extern TScreen Screen1;
extern TButton Button1;
extern TButton * const code Screen1_Buttons[1];




void Button1OnClick();




extern char Button1_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void Check_TP();
void Start_TP();
#line 1 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/uart2.h"
#line 21 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/uart2.h"
void UART2_SetBaud(void);
void UART2_StartRx(void);
void UART2_StartTx(void);

void UART2_Initialize(void);

void UART2_RxQueueInit(void);
char UART2_GetChar(char *rxbyte);

void UART2_Rx(void);
void UART2_Rx1(void);
void UART2_Rx2(void);


void UART2_TxQueueInit(void);
void UART2_PutQueue(char *msg);

void UART2_SendMsg(char *s);
void UART2_CheckQueue(void);
#line 1 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/uart6.h"
#line 20 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/uart6.h"
typedef void (*tPointerFcn)(void);





void UART6_SetBaud(void);
void UART6_StartRx(void);
void UART6_StartTx(void);

void UART6_Initialize(void);

void UART6_RxQueueInit(void);
char UART6_GetChar(char *rxbyte);

void UART6_Rx(void);
void UART6_Rx1(void);
void UART6_Rx2(void);


void UART6_TxQueueInit(void);
void UART6_PutQueue(char *msg);

void UART6_SendMsg(char *s);
void UART6_CheckQueue(void);
#line 1 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/app.h"
#line 19 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/app.h"
void GSM2_Initialize(void);
void GSM2_KeyOn(void);
void GSM2_KeyOff(void);
char GSM2_RdStat(void);
short WaitForResponse(void);
void CheckTimeout(void);

void GSM2_TaskMgr(void);

short GetToken(char *s, char *t);
#line 1 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
#line 9 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
void TimerInit();
void TimerCheck();
#line 31 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
struct timers {
 unsigned long int TimerField;
 unsigned short int Free;
};
#line 43 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
void init_timerpool(void);
#line 52 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
unsigned short int get_timer(void);
#line 61 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
void free_timer(unsigned short int nbr);
#line 71 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
void set_timer(unsigned short int nbr, unsigned long int tout);
#line 80 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
unsigned long int check_timer(unsigned short int nbr);
#line 89 "c:/users/public/projects/arm/projects/gsm2/gsm2_code/mikroc pro for arm/timers.h"
void irqhandler_timer(void);
#line 31 "C:/Users/Public/Projects/ARM/Projects/GSM2/GSM2_Code/mikroC PRO for ARM/GSM2_main.c"
void main() {

 Start_TP();
 UART2_Initialize();
 UART6_Initialize();
 UART6_PutQueue("Started\r\n");
 GSM2_Initialize();
 TimerInit();

 EnableInterrupts();

 while (1) {
 Check_TP();
 UART2_Rx();
 UART2_CheckQueue();
 UART6_Rx();
 UART6_CheckQueue();
 GSM2_TaskMgr();
 TimerCheck();
 }
}
