_UART2_Interrupt:
;UART2.c,51 :: 		void UART2_Interrupt() iv IVT_INT_USART2 ics ICS_AUTO {
;UART2.c,56 :: 		if ((RXNE_USART2_SR_bit) /* || (ORE_bit) */ ) {
MOVW	R1, #lo_addr(RXNE_USART2_SR_bit+0)
MOVT	R1, #hi_addr(RXNE_USART2_SR_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_UART2_Interrupt0
;UART2.c,57 :: 		R_data = USART2_DR;                 // Fetch a byte from receive register
MOVW	R0, #lo_addr(USART2_DR+0)
MOVT	R0, #hi_addr(USART2_DR+0)
; R_data start address is: 12 (R3)
LDR	R3, [R0, #0]
;UART2.c,58 :: 		U2_RxQueue[U2_RxIn++] = R_data;     // Put data byte in re-circulating buffer, increment pointer
MOVW	R2, #lo_addr(_U2_RxIn+0)
MOVT	R2, #hi_addr(_U2_RxIn+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_U2_RxQueue+0)
MOVT	R0, #hi_addr(_U2_RxQueue+0)
ADDS	R0, R0, R1
STRB	R3, [R0, #0]
; R_data end address is: 12 (R3)
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R0, R0, #1
UXTB	R0, R0
STRB	R0, [R2, #0]
;UART2.c,59 :: 		if (U2_RxIn > (U2_rxqsize-1))       // Adjust pointer if necessary
CMP	R0, #255
IT	LS
BLS	L_UART2_Interrupt1
;UART2.c,60 :: 		U2_RxIn = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_U2_RxIn+0)
MOVT	R0, #hi_addr(_U2_RxIn+0)
STRB	R1, [R0, #0]
L_UART2_Interrupt1:
;UART2.c,61 :: 		}
L_UART2_Interrupt0:
;UART2.c,63 :: 		if ((TXE_USART2_SR_bit)&&(TXEIE_USART2_CR1_bit)) {
MOVW	R1, #lo_addr(TXE_USART2_SR_bit+0)
MOVT	R1, #hi_addr(TXE_USART2_SR_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L__UART2_Interrupt31
MOVW	R1, #lo_addr(TXEIE_USART2_CR1_bit+0)
MOVT	R1, #hi_addr(TXEIE_USART2_CR1_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L__UART2_Interrupt30
L__UART2_Interrupt29:
;UART2.c,64 :: 		T_data = U2_XmtBuf[U2_XmtBufPtr++]; // Get a byte from the transmit buffer
MOVW	R2, #lo_addr(_U2_XmtBufPtr+0)
MOVT	R2, #hi_addr(_U2_XmtBufPtr+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_U2_XmtBuf+0)
MOVT	R0, #hi_addr(_U2_XmtBuf+0)
LDR	R0, [R0, #0]
ADDS	R0, R0, R1
LDRB	R1, [R0, #0]
; T_data start address is: 12 (R3)
UXTB	R3, R1
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R0, R0, #1
STRB	R0, [R2, #0]
;UART2.c,65 :: 		if (T_data == NUL) {                // If it is the end of message marker
CMP	R1, #0
IT	NE
BNE	L_UART2_Interrupt5
; T_data end address is: 12 (R3)
;UART2.c,66 :: 		TXEIE_USART2_CR1_bit = 0;       // Disable transmitter interrupts
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(TXEIE_USART2_CR1_bit+0)
MOVT	R0, #hi_addr(TXEIE_USART2_CR1_bit+0)
STR	R1, [R0, #0]
;UART2.c,67 :: 		} else {
IT	AL
BAL	L_UART2_Interrupt6
L_UART2_Interrupt5:
;UART2.c,68 :: 		USART2_DR = T_data;             // Transfer data byte to transmit register
; T_data start address is: 12 (R3)
MOVW	R0, #lo_addr(USART2_DR+0)
MOVT	R0, #hi_addr(USART2_DR+0)
STR	R3, [R0, #0]
; T_data end address is: 12 (R3)
;UART2.c,69 :: 		}
L_UART2_Interrupt6:
;UART2.c,63 :: 		if ((TXE_USART2_SR_bit)&&(TXEIE_USART2_CR1_bit)) {
L__UART2_Interrupt31:
L__UART2_Interrupt30:
;UART2.c,71 :: 		}
L_end_UART2_Interrupt:
BX	LR
; end of _UART2_Interrupt
_UART2_SetBaud:
;UART2.c,75 :: 		void UART2_SetBaud(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART2.c,79 :: 		GPIOAEN_bit = 1;                  // Set GPIOA clock enable bit
MOVS	R2, #1
SXTB	R2, R2
MOVW	R0, #lo_addr(GPIOAEN_bit+0)
MOVT	R0, #hi_addr(GPIOAEN_bit+0)
STR	R2, [R0, #0]
;UART2.c,80 :: 		GPIODEN_bit = 1;                  // Set GPIOD clock enable bit
MOVW	R0, #lo_addr(GPIODEN_bit+0)
MOVT	R0, #hi_addr(GPIODEN_bit+0)
STR	R2, [R0, #0]
;UART2.c,82 :: 		GPIOA_MODER |= 0x00000080;        // Set port A MODER bit 3 to 10: alternate function mode
MOVW	R0, #lo_addr(GPIOA_MODER+0)
MOVT	R0, #hi_addr(GPIOA_MODER+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #128
MOVW	R0, #lo_addr(GPIOA_MODER+0)
MOVT	R0, #hi_addr(GPIOA_MODER+0)
STR	R1, [R0, #0]
;UART2.c,83 :: 		GPIOD_MODER |= 0x00000800;        // Set port D MODER bit 5 to 10: alternate function mode
MOVW	R0, #lo_addr(GPIOD_MODER+0)
MOVT	R0, #hi_addr(GPIOD_MODER+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #2048
MOVW	R0, #lo_addr(GPIOD_MODER+0)
MOVT	R0, #hi_addr(GPIOD_MODER+0)
STR	R1, [R0, #0]
;UART2.c,85 :: 		GPIOA_AFRL |= 0x00007000;         // Select alternate function 0111: AF7 for port A bit 3
MOVW	R0, #lo_addr(GPIOA_AFRL+0)
MOVT	R0, #hi_addr(GPIOA_AFRL+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #28672
MOVW	R0, #lo_addr(GPIOA_AFRL+0)
MOVT	R0, #hi_addr(GPIOA_AFRL+0)
STR	R1, [R0, #0]
;UART2.c,86 :: 		GPIOD_AFRL |= 0x00700000;         // Select alternate function 0111: AF7 for port D bit 35
MOVW	R0, #lo_addr(GPIOD_AFRL+0)
MOVT	R0, #hi_addr(GPIOD_AFRL+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #7340032
MOVW	R0, #lo_addr(GPIOD_AFRL+0)
MOVT	R0, #hi_addr(GPIOD_AFRL+0)
STR	R1, [R0, #0]
;UART2.c,88 :: 		USART2EN_bit = 1;                 // Set USART2 clock enable bit
MOVW	R0, #lo_addr(USART2EN_bit+0)
MOVT	R0, #hi_addr(USART2EN_bit+0)
STR	R2, [R0, #0]
;UART2.c,89 :: 		USART2_CR1 = 0x200C;              // Set UE, TE, and RE in USART2 control register 1
MOVW	R1, #8204
MOVW	R0, #lo_addr(USART2_CR1+0)
MOVT	R0, #hi_addr(USART2_CR1+0)
STR	R1, [R0, #0]
;UART2.c,90 :: 		USART2_BRR = 0x0F42;              // Set baud rate register for 9600
MOVW	R1, #3906
MOVW	R0, #lo_addr(USART2_BRR+0)
MOVT	R0, #hi_addr(USART2_BRR+0)
STR	R1, [R0, #0]
;UART2.c,92 :: 		NVIC_IntEnable(IVT_INT_USART2);   // Eneble interrupt vector
MOVW	R0, #54
BL	_NVIC_IntEnable+0
;UART2.c,93 :: 		}
L_end_UART2_SetBaud:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART2_SetBaud
_UART2_StartRx:
;UART2.c,97 :: 		void UART2_StartRx(void) {
;UART2.c,98 :: 		RXNEIE_USART2_CR1_bit = 1;        // Interrupt when receive buffer is full (RXNE=1)
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(RXNEIE_USART2_CR1_bit+0)
MOVT	R0, #hi_addr(RXNEIE_USART2_CR1_bit+0)
STR	R1, [R0, #0]
;UART2.c,99 :: 		}
L_end_UART2_StartRx:
BX	LR
; end of _UART2_StartRx
_UART2_StartTx:
;UART2.c,103 :: 		void UART2_StartTx(void) {
;UART2.c,104 :: 		TXEIE_USART2_CR1_bit = 1;         // Interrupt when transmit buffer is empty (TXE=1)
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(TXEIE_USART2_CR1_bit+0)
MOVT	R0, #hi_addr(TXEIE_USART2_CR1_bit+0)
STR	R1, [R0, #0]
;UART2.c,105 :: 		}
L_end_UART2_StartTx:
BX	LR
; end of _UART2_StartTx
_UART2_Initialize:
;UART2.c,114 :: 		void UART2_Initialize(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART2.c,115 :: 		UART2_RxQueueInit();
BL	_UART2_RxQueueInit+0
;UART2.c,116 :: 		UART2_TxQueueInit();
BL	_UART2_TxQueueInit+0
;UART2.c,118 :: 		UART2_SetBaud();
BL	_UART2_SetBaud+0
;UART2.c,119 :: 		UART2_StartRx();
BL	_UART2_StartRx+0
;UART2.c,120 :: 		}
L_end_UART2_Initialize:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART2_Initialize
_UART2_RxQueueInit:
;UART2.c,125 :: 		void UART2_RxQueueInit(void) {
;UART2.c,126 :: 		U2_RxIn = U2_RxOut = 0;           // Set pointers to 0
MOVS	R1, #0
MOVW	R0, #lo_addr(_U2_RxOut+0)
MOVT	R0, #hi_addr(_U2_RxOut+0)
STRB	R1, [R0, #0]
MOVS	R1, #0
MOVW	R0, #lo_addr(_U2_RxIn+0)
MOVT	R0, #hi_addr(_U2_RxIn+0)
STRB	R1, [R0, #0]
;UART2.c,127 :: 		U2_RcvBufPtr = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_U2_RcvBufPtr+0)
MOVT	R0, #hi_addr(_U2_RcvBufPtr+0)
STRB	R1, [R0, #0]
;UART2.c,128 :: 		}
L_end_UART2_RxQueueInit:
BX	LR
; end of _UART2_RxQueueInit
_UART2_GetChar:
;UART2.c,134 :: 		char UART2_GetChar(char *rxbyte) {
;UART2.c,135 :: 		if (U2_RxIn != U2_RxOut) {              // If there is a character in the buffer
MOVW	R1, #lo_addr(_U2_RxOut+0)
MOVT	R1, #hi_addr(_U2_RxOut+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(_U2_RxIn+0)
MOVT	R1, #hi_addr(_U2_RxIn+0)
LDRB	R1, [R1, #0]
CMP	R1, R2
IT	EQ
BEQ	L_UART2_GetChar7
;UART2.c,136 :: 		*rxbyte = U2_RxQueue[U2_RxOut++];    // Extract the character and update the pointer
MOVW	R3, #lo_addr(_U2_RxOut+0)
MOVT	R3, #hi_addr(_U2_RxOut+0)
LDRB	R2, [R3, #0]
MOVW	R1, #lo_addr(_U2_RxQueue+0)
MOVT	R1, #hi_addr(_U2_RxQueue+0)
ADDS	R1, R1, R2
LDRB	R1, [R1, #0]
STRB	R1, [R0, #0]
MOV	R1, R3
LDRB	R1, [R1, #0]
ADDS	R1, R1, #1
UXTB	R1, R1
STRB	R1, [R3, #0]
;UART2.c,137 :: 		if (U2_RxOut > (U2_rxqsize-1))       // Check for wrap
CMP	R1, #255
IT	LS
BLS	L_UART2_GetChar8
;UART2.c,138 :: 		U2_RxOut = 0;
MOVS	R2, #0
MOVW	R1, #lo_addr(_U2_RxOut+0)
MOVT	R1, #hi_addr(_U2_RxOut+0)
STRB	R2, [R1, #0]
L_UART2_GetChar8:
;UART2.c,139 :: 		return 1;
MOVS	R0, #1
IT	AL
BAL	L_end_UART2_GetChar
;UART2.c,140 :: 		}else{
L_UART2_GetChar7:
;UART2.c,141 :: 		return 0;                            // No data available
MOVS	R0, #0
;UART2.c,143 :: 		}
L_end_UART2_GetChar:
BX	LR
; end of _UART2_GetChar
_UART2_Rx:
;UART2.c,147 :: 		void UART2_Rx(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART2.c,148 :: 		UART2_RxFuncPtr();      // Use the function pointer to go to a state
MOVW	R4, #lo_addr(_UART2_RxFuncPtr+0)
MOVT	R4, #hi_addr(_UART2_RxFuncPtr+0)
LDR	R4, [R4, #0]
BLX	R4
;UART2.c,149 :: 		}
L_end_UART2_Rx:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART2_Rx
_UART2_Rx1:
;UART2.c,154 :: 		void UART2_Rx1(void){
SUB	SP, SP, #8
STR	LR, [SP, #0]
;UART2.c,157 :: 		if (UART2_GetChar(&rxchar)) {
ADD	R0, SP, #4
BL	_UART2_GetChar+0
CMP	R0, #0
IT	EQ
BEQ	L_UART2_Rx110
;UART2.c,158 :: 		switch (rxchar) {
IT	AL
BAL	L_UART2_Rx111
;UART2.c,159 :: 		case NUL:       // Discard NUL character
L_UART2_Rx113:
;UART2.c,160 :: 		break;
IT	AL
BAL	L_UART2_Rx112
;UART2.c,162 :: 		case '\r':
L_UART2_Rx114:
;UART2.c,163 :: 		U2_RcvBuf[U2_RcvBufPtr++] = rxchar;       // Put return character in buffer
MOVW	R2, #lo_addr(_U2_RcvBufPtr+0)
MOVT	R2, #hi_addr(_U2_RcvBufPtr+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_U2_RcvBuf+0)
MOVT	R0, #hi_addr(_U2_RcvBuf+0)
ADDS	R1, R0, R1
LDRB	R0, [SP, #4]
STRB	R0, [R1, #0]
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R0, R0, #1
STRB	R0, [R2, #0]
;UART2.c,164 :: 		break;
IT	AL
BAL	L_UART2_Rx112
;UART2.c,166 :: 		case '\n':
L_UART2_Rx115:
;UART2.c,167 :: 		U2_RcvBuf[U2_RcvBufPtr++] = rxchar;       // Put new line character into buffer
MOVW	R2, #lo_addr(_U2_RcvBufPtr+0)
MOVT	R2, #hi_addr(_U2_RcvBufPtr+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_U2_RcvBuf+0)
MOVT	R0, #hi_addr(_U2_RcvBuf+0)
ADDS	R1, R0, R1
LDRB	R0, [SP, #4]
STRB	R0, [R1, #0]
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R1, R0, #1
UXTB	R1, R1
STRB	R1, [R2, #0]
;UART2.c,168 :: 		U2_RcvBuf[U2_RcvBufPtr] = 0;              // Put end marker into buffer
MOVW	R0, #lo_addr(_U2_RcvBuf+0)
MOVT	R0, #hi_addr(_U2_RcvBuf+0)
ADDS	R1, R0, R1
MOVS	R0, #0
STRB	R0, [R1, #0]
;UART2.c,169 :: 		U2_RcvBufPtr = 0;                         // Point to start of buffer
MOVS	R0, #0
STRB	R0, [R2, #0]
;UART2.c,171 :: 		U2_MsgFlg = 1;                            // Indicate message available
MOVS	R1, #1
MOVW	R0, #lo_addr(_U2_MsgFlg+0)
MOVT	R0, #hi_addr(_U2_MsgFlg+0)
STRB	R1, [R0, #0]
;UART2.c,173 :: 		UART2_RxFuncPtr = UART2_Rx2;              // Go to state 2
MOVW	R1, #lo_addr(_UART2_Rx2+0)
MOVT	R1, #hi_addr(_UART2_Rx2+0)
MOVW	R0, #lo_addr(_UART2_RxFuncPtr+0)
MOVT	R0, #hi_addr(_UART2_RxFuncPtr+0)
STR	R1, [R0, #0]
;UART2.c,174 :: 		break;
IT	AL
BAL	L_UART2_Rx112
;UART2.c,176 :: 		case '>':
L_UART2_Rx116:
;UART2.c,177 :: 		U2_RcvBuf[U2_RcvBufPtr++] = rxchar;
MOVW	R2, #lo_addr(_U2_RcvBufPtr+0)
MOVT	R2, #hi_addr(_U2_RcvBufPtr+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_U2_RcvBuf+0)
MOVT	R0, #hi_addr(_U2_RcvBuf+0)
ADDS	R1, R0, R1
LDRB	R0, [SP, #4]
STRB	R0, [R1, #0]
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R0, R0, #1
STRB	R0, [R2, #0]
;UART2.c,178 :: 		PromptFlag = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_PromptFlag+0)
MOVT	R0, #hi_addr(_PromptFlag+0)
STRB	R1, [R0, #0]
;UART2.c,179 :: 		break;
IT	AL
BAL	L_UART2_Rx112
;UART2.c,181 :: 		case ' ':
L_UART2_Rx117:
;UART2.c,182 :: 		U2_RcvBuf[U2_RcvBufPtr++] = rxchar;
MOVW	R2, #lo_addr(_U2_RcvBufPtr+0)
MOVT	R2, #hi_addr(_U2_RcvBufPtr+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_U2_RcvBuf+0)
MOVT	R0, #hi_addr(_U2_RcvBuf+0)
ADDS	R1, R0, R1
LDRB	R0, [SP, #4]
STRB	R0, [R1, #0]
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R0, R0, #1
STRB	R0, [R2, #0]
;UART2.c,183 :: 		if (PromptFlag == 1) {
MOVW	R0, #lo_addr(_PromptFlag+0)
MOVT	R0, #hi_addr(_PromptFlag+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L_UART2_Rx118
;UART2.c,184 :: 		U2_RcvBuf[U2_RcvBufPtr] = 0;               // Put end marker into buffer
MOVW	R2, #lo_addr(_U2_RcvBufPtr+0)
MOVT	R2, #hi_addr(_U2_RcvBufPtr+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_U2_RcvBuf+0)
MOVT	R0, #hi_addr(_U2_RcvBuf+0)
ADDS	R1, R0, R1
MOVS	R0, #0
STRB	R0, [R1, #0]
;UART2.c,185 :: 		U2_RcvBufPtr = 0;                          // Point to start of buffer
MOVS	R0, #0
STRB	R0, [R2, #0]
;UART2.c,186 :: 		U2_MsgFlg = 1;                             // Indicate message available
MOVS	R1, #1
MOVW	R0, #lo_addr(_U2_MsgFlg+0)
MOVT	R0, #hi_addr(_U2_MsgFlg+0)
STRB	R1, [R0, #0]
;UART2.c,187 :: 		}
L_UART2_Rx118:
;UART2.c,188 :: 		PromptFlag = 0;                                // Clear prompt flag regardless
MOVS	R1, #0
MOVW	R0, #lo_addr(_PromptFlag+0)
MOVT	R0, #hi_addr(_PromptFlag+0)
STRB	R1, [R0, #0]
;UART2.c,189 :: 		break;
IT	AL
BAL	L_UART2_Rx112
;UART2.c,191 :: 		default:
L_UART2_Rx119:
;UART2.c,192 :: 		if ((rxchar > 31) && (rxchar < 127)) {         // Use only ASCII set
LDRB	R0, [SP, #4]
CMP	R0, #31
IT	LS
BLS	L__UART2_Rx134
LDRB	R0, [SP, #4]
CMP	R0, #127
IT	CS
BCS	L__UART2_Rx133
L__UART2_Rx132:
;UART2.c,193 :: 		if (U2_RcvBufPtr < (U2_RcvBufSize-2))     // Prevents buffer overrun
MOVW	R0, #lo_addr(_U2_RcvBufPtr+0)
MOVT	R0, #hi_addr(_U2_RcvBufPtr+0)
LDRB	R0, [R0, #0]
CMP	R0, #254
IT	CS
BCS	L_UART2_Rx123
;UART2.c,194 :: 		U2_RcvBuf[U2_RcvBufPtr++] = rxchar;   // Put character in buffer
MOVW	R2, #lo_addr(_U2_RcvBufPtr+0)
MOVT	R2, #hi_addr(_U2_RcvBufPtr+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_U2_RcvBuf+0)
MOVT	R0, #hi_addr(_U2_RcvBuf+0)
ADDS	R1, R0, R1
LDRB	R0, [SP, #4]
STRB	R0, [R1, #0]
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R0, R0, #1
STRB	R0, [R2, #0]
L_UART2_Rx123:
;UART2.c,192 :: 		if ((rxchar > 31) && (rxchar < 127)) {         // Use only ASCII set
L__UART2_Rx134:
L__UART2_Rx133:
;UART2.c,196 :: 		break;
IT	AL
BAL	L_UART2_Rx112
;UART2.c,197 :: 		}
L_UART2_Rx111:
LDRB	R0, [SP, #4]
CMP	R0, #0
IT	EQ
BEQ	L_UART2_Rx113
LDRB	R0, [SP, #4]
CMP	R0, #13
IT	EQ
BEQ	L_UART2_Rx114
LDRB	R0, [SP, #4]
CMP	R0, #10
IT	EQ
BEQ	L_UART2_Rx115
LDRB	R0, [SP, #4]
CMP	R0, #62
IT	EQ
BEQ	L_UART2_Rx116
LDRB	R0, [SP, #4]
CMP	R0, #32
IT	EQ
BEQ	L_UART2_Rx117
IT	AL
BAL	L_UART2_Rx119
L_UART2_Rx112:
;UART2.c,198 :: 		}
L_UART2_Rx110:
;UART2.c,199 :: 		}
L_end_UART2_Rx1:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _UART2_Rx1
_UART2_Rx2:
;UART2.c,203 :: 		void UART2_Rx2(void) {
;UART2.c,204 :: 		if (U2_MsgFlg == 0) {
MOVW	R0, #lo_addr(_U2_MsgFlg+0)
MOVT	R0, #hi_addr(_U2_MsgFlg+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_UART2_Rx224
;UART2.c,205 :: 		UART2_RxFuncPtr = UART2_Rx1;  // Go back to state 1
MOVW	R1, #lo_addr(_UART2_Rx1+0)
MOVT	R1, #hi_addr(_UART2_Rx1+0)
MOVW	R0, #lo_addr(_UART2_RxFuncPtr+0)
MOVT	R0, #hi_addr(_UART2_RxFuncPtr+0)
STR	R1, [R0, #0]
;UART2.c,206 :: 		}
L_UART2_Rx224:
;UART2.c,207 :: 		}
L_end_UART2_Rx2:
BX	LR
; end of _UART2_Rx2
_UART2_TxQueueInit:
;UART2.c,214 :: 		void UART2_TxQueueInit(void) {
;UART2.c,215 :: 		U2_TxIn = U2_TxOut = 0;           // Set pointers to 0
MOVS	R1, #0
MOVW	R0, #lo_addr(_U2_TxOut+0)
MOVT	R0, #hi_addr(_U2_TxOut+0)
STRB	R1, [R0, #0]
MOVS	R1, #0
MOVW	R0, #lo_addr(_U2_TxIn+0)
MOVT	R0, #hi_addr(_U2_TxIn+0)
STRB	R1, [R0, #0]
;UART2.c,216 :: 		U2_XmtBufPtr = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_U2_XmtBufPtr+0)
MOVT	R0, #hi_addr(_U2_XmtBufPtr+0)
STRB	R1, [R0, #0]
;UART2.c,217 :: 		}
L_end_UART2_TxQueueInit:
BX	LR
; end of _UART2_TxQueueInit
_UART2_PutQueue:
;UART2.c,222 :: 		void UART2_PutQueue(char *msg) {
;UART2.c,223 :: 		U2_TxQueue[U2_TxIn++] = msg;      // Put the message pointer into FIFO
MOVW	R3, #lo_addr(_U2_TxIn+0)
MOVT	R3, #hi_addr(_U2_TxIn+0)
LDRB	R1, [R3, #0]
LSLS	R2, R1, #2
MOVW	R1, #lo_addr(_U2_TxQueue+0)
MOVT	R1, #hi_addr(_U2_TxQueue+0)
ADDS	R1, R1, R2
STR	R0, [R1, #0]
MOV	R1, R3
LDRB	R1, [R1, #0]
ADDS	R1, R1, #1
UXTB	R1, R1
STRB	R1, [R3, #0]
;UART2.c,224 :: 		if (U2_TxIn > (U2_txqsize-1))     // Adjust FIFO in pointer
CMP	R1, #63
IT	LS
BLS	L_UART2_PutQueue25
;UART2.c,225 :: 		U2_TxIn = 0;
MOVS	R2, #0
MOVW	R1, #lo_addr(_U2_TxIn+0)
MOVT	R1, #hi_addr(_U2_TxIn+0)
STRB	R2, [R1, #0]
L_UART2_PutQueue25:
;UART2.c,226 :: 		}
L_end_UART2_PutQueue:
BX	LR
; end of _UART2_PutQueue
_UART2_SendMsg:
;UART2.c,230 :: 		void UART2_SendMsg(char *s) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART2.c,231 :: 		U2_XmtBuf = s;                    // Pointer to the message for the interrupt handler
MOVW	R1, #lo_addr(_U2_XmtBuf+0)
MOVT	R1, #hi_addr(_U2_XmtBuf+0)
STR	R0, [R1, #0]
;UART2.c,232 :: 		U2_XmtBufPtr = 0;                 // Set character counter to start of text message
MOVS	R2, #0
MOVW	R1, #lo_addr(_U2_XmtBufPtr+0)
MOVT	R1, #hi_addr(_U2_XmtBufPtr+0)
STRB	R2, [R1, #0]
;UART2.c,233 :: 		UART2_StartTx();                  // Turn on the transmitter
BL	_UART2_StartTx+0
;UART2.c,234 :: 		}
L_end_UART2_SendMsg:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART2_SendMsg
_UART2_CheckQueue:
;UART2.c,239 :: 		void UART2_CheckQueue(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART2.c,240 :: 		if (TXEIE_USART2_CR1_bit == 0) {  // Don't try to start transmitter if already transmitting
MOVW	R1, #lo_addr(TXEIE_USART2_CR1_bit+0)
MOVT	R1, #hi_addr(TXEIE_USART2_CR1_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	NE
BNE	L_UART2_CheckQueue26
;UART2.c,241 :: 		if (U2_TxIn != U2_TxOut) {                 // If pointers are not the same
MOVW	R0, #lo_addr(_U2_TxOut+0)
MOVT	R0, #hi_addr(_U2_TxOut+0)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_U2_TxIn+0)
MOVT	R0, #hi_addr(_U2_TxIn+0)
LDRB	R0, [R0, #0]
CMP	R0, R1
IT	EQ
BEQ	L_UART2_CheckQueue27
;UART2.c,242 :: 		UART2_SendMsg(U2_TxQueue[U2_TxOut++]); // Hand off the message pointer and increment counter
MOVW	R0, #lo_addr(_U2_TxOut+0)
MOVT	R0, #hi_addr(_U2_TxOut+0)
LDRB	R0, [R0, #0]
LSLS	R1, R0, #2
MOVW	R0, #lo_addr(_U2_TxQueue+0)
MOVT	R0, #hi_addr(_U2_TxQueue+0)
ADDS	R0, R0, R1
LDR	R0, [R0, #0]
BL	_UART2_SendMsg+0
MOVW	R1, #lo_addr(_U2_TxOut+0)
MOVT	R1, #hi_addr(_U2_TxOut+0)
LDRB	R0, [R1, #0]
ADDS	R0, R0, #1
UXTB	R0, R0
STRB	R0, [R1, #0]
;UART2.c,243 :: 		if (U2_TxOut > (U2_txqsize-1))         // Check for wrap
CMP	R0, #63
IT	LS
BLS	L_UART2_CheckQueue28
;UART2.c,244 :: 		U2_TxOut = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_U2_TxOut+0)
MOVT	R0, #hi_addr(_U2_TxOut+0)
STRB	R1, [R0, #0]
L_UART2_CheckQueue28:
;UART2.c,245 :: 		}
L_UART2_CheckQueue27:
;UART2.c,246 :: 		}
L_UART2_CheckQueue26:
;UART2.c,247 :: 		}
L_end_UART2_CheckQueue:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART2_CheckQueue
