/**************************************************************************************************
  UART6.h
**************************************************************************************************/
#ifndef UART6_H
#define UART6_H


// Defines
#define DC3 0x13         // XOFF control character
#define DC1 0x11         // XON control character
#define NUL 0x00         // NUL control character


#define RcvBufSize 256   // Number of bytes in Receive Buffer
#define rxqsize 256      // Number of characters in receive buffer queue
#define txqsize 64       // Number of pointers in transmit queue



typedef void (*tPointerFcn)(void);  // Pointer to a function




// Function Prototypes
void UART6_SetBaud(void);
void UART6_StartRx(void);
void UART6_StartTx(void);

void UART6_Initialize(void);

void UART6_RxQueueInit(void);
char UART6_GetChar(char *rxbyte);

void UART6_Rx(void);
void UART6_Rx1(void);
void UART6_Rx2(void);


void UART6_TxQueueInit(void);
void UART6_PutQueue(char *msg);

void UART6_SendMsg(char *s);
void UART6_CheckQueue(void);




#endif